<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!--NewPage-->
<HTML>
<HEAD>
<!-- Generated by javadoc (build 1.6.0_35) on Wed Nov 28 22:36:52 CET 2012 -->
<META http-equiv="Content-Type" content="text/html; charset=UTF-8">
<TITLE>
HttpAsyncService (HttpCore NIO 4.2.3 API)
</TITLE>

<META NAME="date" CONTENT="2012-11-28">

<LINK REL ="stylesheet" TYPE="text/css" HREF="../../../../../stylesheet.css" TITLE="Style">

<SCRIPT type="text/javascript">
function windowTitle()
{
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="HttpAsyncService (HttpCore NIO 4.2.3 API)";
    }
}
</SCRIPT>
<NOSCRIPT>
</NOSCRIPT>

</HEAD>

<BODY BGCOLOR="white" onload="windowTitle();">
<HR>


<!-- ========= START OF TOP NAVBAR ======= -->
<A NAME="navbar_top"><!-- --></A>
<A HREF="#skip-navbar_top" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_top_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="class-use/HttpAsyncService.html"><FONT CLASS="NavBarFont1"><B>Use</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../index-all.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../../../org/apache/http/nio/protocol/HttpAsyncResponseProducer.html" title="interface in org.apache.http.nio.protocol"><B>PREV CLASS</B></A>&nbsp;
&nbsp;<A HREF="../../../../../org/apache/http/nio/protocol/HttpRequestExecutionHandler.html" title="interface in org.apache.http.nio.protocol"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../../index.html?org/apache/http/nio/protocol/HttpAsyncService.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="HttpAsyncService.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;NESTED&nbsp;|&nbsp;FIELD&nbsp;|&nbsp;<A HREF="#constructor_summary">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;FIELD&nbsp;|&nbsp;<A HREF="#constructor_detail">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_top"></A>
<!-- ========= END OF TOP NAVBAR ========= -->

<HR>
<!-- ======== START OF CLASS DATA ======== -->
<H2>
<FONT SIZE="-1">
org.apache.http.nio.protocol</FONT>
<BR>
Class HttpAsyncService</H2>
<PRE>
<A HREF="http://download.oracle.com/javase/1.5.0/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">java.lang.Object</A>
  <IMG SRC="../../../../../resources/inherit.gif" ALT="extended by "><B>org.apache.http.nio.protocol.HttpAsyncService</B>
</PRE>
<DL>
<DT><B>All Implemented Interfaces:</B> <DD><A HREF="../../../../../org/apache/http/nio/NHttpServerEventHandler.html" title="interface in org.apache.http.nio">NHttpServerEventHandler</A></DD>
</DL>
<HR>
<DL>
<DT><PRE><FONT SIZE="-1"><A HREF="http://hc.apache.org/httpcomponents-core-ga/httpcore/apidocs/org/apache/http/annotation/Immutable.html?is-external=true" title="class or interface in org.apache.http.annotation">@Immutable</A>
</FONT>public class <B>HttpAsyncService</B><DT>extends <A HREF="http://download.oracle.com/javase/1.5.0/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</A><DT>implements <A HREF="../../../../../org/apache/http/nio/NHttpServerEventHandler.html" title="interface in org.apache.http.nio">NHttpServerEventHandler</A></DL>
</PRE>

<P>
<tt>HttpAsyncService</tt> is a fully asynchronous HTTP server side protocol
 handler based on the non-blocking (NIO) I/O model.
 <tt>HttpAsyncServerProtocolHandler</tt> translates individual events fired
 through the <A HREF="../../../../../org/apache/http/nio/NHttpServerEventHandler.html" title="interface in org.apache.http.nio"><CODE>NHttpServerEventHandler</CODE></A> interface into logically related
 HTTP message exchanges.
 <p/>
 Upon receiving an incoming request <tt>HttpAsyncService</tt> verifies
 the message for compliance with the server expectations using
 <A HREF="../../../../../org/apache/http/nio/protocol/HttpAsyncExpectationVerifier.html" title="interface in org.apache.http.nio.protocol"><CODE>HttpAsyncExpectationVerifier</CODE></A>, if provided, and then
 <A HREF="../../../../../org/apache/http/nio/protocol/HttpAsyncRequestHandlerResolver.html" title="interface in org.apache.http.nio.protocol"><CODE>HttpAsyncRequestHandlerResolver</CODE></A> is used to resolve the request URI
 to a particular <A HREF="../../../../../org/apache/http/nio/protocol/HttpAsyncRequestHandler.html" title="interface in org.apache.http.nio.protocol"><CODE>HttpAsyncRequestHandler</CODE></A> intended to handle
 the request with the given URI. The protocol handler uses the selected
 <A HREF="../../../../../org/apache/http/nio/protocol/HttpAsyncRequestHandler.html" title="interface in org.apache.http.nio.protocol"><CODE>HttpAsyncRequestHandler</CODE></A> instance to process the incoming request
 and to generate an outgoing response.
 <p/>
 <tt>HttpAsyncService</tt> relies on <A HREF="http://hc.apache.org/httpcomponents-core-ga/httpcore/apidocs/org/apache/http/protocol/HttpProcessor.html?is-external=true" title="class or interface in org.apache.http.protocol"><CODE>HttpProcessor</CODE></A> to generate
 mandatory protocol headers for all outgoing messages and apply common,
 cross-cutting message transformations to all incoming and outgoing messages,
 whereas individual <A HREF="../../../../../org/apache/http/nio/protocol/HttpAsyncRequestHandler.html" title="interface in org.apache.http.nio.protocol"><CODE>HttpAsyncRequestHandler</CODE></A>s are expected
 to implement application specific content generation and processing.
 <p/>
 Individual <A HREF="../../../../../org/apache/http/nio/protocol/HttpAsyncRequestHandler.html" title="interface in org.apache.http.nio.protocol"><CODE>HttpAsyncRequestHandler</CODE></A>s do not have to submit a response
 immediately. They can defer transmission of an HTTP response back to
 the client without blocking the I/O thread by delegating the process of
 request handling to another service or a worker thread. HTTP response can
 be submitted as a later a later point of time once response content becomes
 available.
 <p/>
 The following parameters can be used to customize the behavior of this
 class:
 <ul>
  <li><A HREF="http://hc.apache.org/httpcomponents-core-ga/httpcore/apidocs/org/apache/http/params/CoreConnectionPNames.html?is-external=true#SO_TIMEOUT" title="class or interface in org.apache.http.params"><CODE>CoreConnectionPNames.SO_TIMEOUT</CODE></A></li>
 </ul>
<P>

<P>
<DL>
<DT><B>Since:</B></DT>
  <DD>4.2</DD>
</DL>
<HR>

<P>

<!-- ======== CONSTRUCTOR SUMMARY ======== -->

<A NAME="constructor_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Constructor Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><B><A HREF="../../../../../org/apache/http/nio/protocol/HttpAsyncService.html#HttpAsyncService(org.apache.http.protocol.HttpProcessor, org.apache.http.ConnectionReuseStrategy, org.apache.http.nio.protocol.HttpAsyncRequestHandlerResolver, org.apache.http.params.HttpParams)">HttpAsyncService</A></B>(<A HREF="http://hc.apache.org/httpcomponents-core-ga/httpcore/apidocs/org/apache/http/protocol/HttpProcessor.html?is-external=true" title="class or interface in org.apache.http.protocol">HttpProcessor</A>&nbsp;httpProcessor,
                 <A HREF="http://hc.apache.org/httpcomponents-core-ga/httpcore/apidocs/org/apache/http/ConnectionReuseStrategy.html?is-external=true" title="class or interface in org.apache.http">ConnectionReuseStrategy</A>&nbsp;connStrategy,
                 <A HREF="../../../../../org/apache/http/nio/protocol/HttpAsyncRequestHandlerResolver.html" title="interface in org.apache.http.nio.protocol">HttpAsyncRequestHandlerResolver</A>&nbsp;handlerResolver,
                 <A HREF="http://hc.apache.org/httpcomponents-core-ga/httpcore/apidocs/org/apache/http/params/HttpParams.html?is-external=true" title="class or interface in org.apache.http.params">HttpParams</A>&nbsp;params)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Creates an instance of <tt>HttpAsyncServerProtocolHandler</tt>.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><B><A HREF="../../../../../org/apache/http/nio/protocol/HttpAsyncService.html#HttpAsyncService(org.apache.http.protocol.HttpProcessor, org.apache.http.ConnectionReuseStrategy, org.apache.http.HttpResponseFactory, org.apache.http.nio.protocol.HttpAsyncRequestHandlerResolver, org.apache.http.nio.protocol.HttpAsyncExpectationVerifier, org.apache.http.params.HttpParams)">HttpAsyncService</A></B>(<A HREF="http://hc.apache.org/httpcomponents-core-ga/httpcore/apidocs/org/apache/http/protocol/HttpProcessor.html?is-external=true" title="class or interface in org.apache.http.protocol">HttpProcessor</A>&nbsp;httpProcessor,
                 <A HREF="http://hc.apache.org/httpcomponents-core-ga/httpcore/apidocs/org/apache/http/ConnectionReuseStrategy.html?is-external=true" title="class or interface in org.apache.http">ConnectionReuseStrategy</A>&nbsp;connStrategy,
                 <A HREF="http://hc.apache.org/httpcomponents-core-ga/httpcore/apidocs/org/apache/http/HttpResponseFactory.html?is-external=true" title="class or interface in org.apache.http">HttpResponseFactory</A>&nbsp;responseFactory,
                 <A HREF="../../../../../org/apache/http/nio/protocol/HttpAsyncRequestHandlerResolver.html" title="interface in org.apache.http.nio.protocol">HttpAsyncRequestHandlerResolver</A>&nbsp;handlerResolver,
                 <A HREF="../../../../../org/apache/http/nio/protocol/HttpAsyncExpectationVerifier.html" title="interface in org.apache.http.nio.protocol">HttpAsyncExpectationVerifier</A>&nbsp;expectationVerifier,
                 <A HREF="http://hc.apache.org/httpcomponents-core-ga/httpcore/apidocs/org/apache/http/params/HttpParams.html?is-external=true" title="class or interface in org.apache.http.params">HttpParams</A>&nbsp;params)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Creates an instance of <tt>HttpAsyncServerProtocolHandler</tt>.</TD>
</TR>
</TABLE>
&nbsp;
<!-- ========== METHOD SUMMARY =========== -->

<A NAME="method_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Method Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/http/nio/protocol/HttpAsyncService.html#closed(org.apache.http.nio.NHttpServerConnection)">closed</A></B>(<A HREF="../../../../../org/apache/http/nio/NHttpServerConnection.html" title="interface in org.apache.http.nio">NHttpServerConnection</A>&nbsp;conn)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Triggered when the connection is closed.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/http/nio/protocol/HttpAsyncService.html#connected(org.apache.http.nio.NHttpServerConnection)">connected</A></B>(<A HREF="../../../../../org/apache/http/nio/NHttpServerConnection.html" title="interface in org.apache.http.nio">NHttpServerConnection</A>&nbsp;conn)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Triggered when a new incoming connection is created.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/http/nio/protocol/HttpAsyncService.html#endOfInput(org.apache.http.nio.NHttpServerConnection)">endOfInput</A></B>(<A HREF="../../../../../org/apache/http/nio/NHttpServerConnection.html" title="interface in org.apache.http.nio">NHttpServerConnection</A>&nbsp;conn)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Triggered when the connection is closed by the opposite end point
 (half-closed).</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/http/nio/protocol/HttpAsyncService.html#exception(org.apache.http.nio.NHttpServerConnection, java.lang.Exception)">exception</A></B>(<A HREF="../../../../../org/apache/http/nio/NHttpServerConnection.html" title="interface in org.apache.http.nio">NHttpServerConnection</A>&nbsp;conn,
          <A HREF="http://download.oracle.com/javase/1.5.0/docs/api/java/lang/Exception.html?is-external=true" title="class or interface in java.lang">Exception</A>&nbsp;cause)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Triggered if an error occurs during the HTTP exchange.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;<A HREF="../../../../../org/apache/http/nio/protocol/HttpAsyncResponseProducer.html" title="interface in org.apache.http.nio.protocol">HttpAsyncResponseProducer</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/http/nio/protocol/HttpAsyncService.html#handleException(java.lang.Exception, org.apache.http.protocol.HttpContext)">handleException</A></B>(<A HREF="http://download.oracle.com/javase/1.5.0/docs/api/java/lang/Exception.html?is-external=true" title="class or interface in java.lang">Exception</A>&nbsp;ex,
                <A HREF="http://hc.apache.org/httpcomponents-core-ga/httpcore/apidocs/org/apache/http/protocol/HttpContext.html?is-external=true" title="class or interface in org.apache.http.protocol">HttpContext</A>&nbsp;context)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/http/nio/protocol/HttpAsyncService.html#inputReady(org.apache.http.nio.NHttpServerConnection, org.apache.http.nio.ContentDecoder)">inputReady</A></B>(<A HREF="../../../../../org/apache/http/nio/NHttpServerConnection.html" title="interface in org.apache.http.nio">NHttpServerConnection</A>&nbsp;conn,
           <A HREF="../../../../../org/apache/http/nio/ContentDecoder.html" title="interface in org.apache.http.nio">ContentDecoder</A>&nbsp;decoder)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Triggered when the underlying channel is ready for reading a
 new portion of the request entity through the corresponding
 content decoder.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/http/nio/protocol/HttpAsyncService.html#log(java.lang.Exception)">log</A></B>(<A HREF="http://download.oracle.com/javase/1.5.0/docs/api/java/lang/Exception.html?is-external=true" title="class or interface in java.lang">Exception</A>&nbsp;ex)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;This method can be used to log I/O exception thrown while closing <A HREF="http://download.oracle.com/javase/1.5.0/docs/api/java/io/Closeable.html?is-external=true" title="class or interface in java.io"><CODE>Closeable</CODE></A>
 objects (such as <A HREF="http://hc.apache.org/httpcomponents-core-ga/httpcore/apidocs/org/apache/http/HttpConnection.html?is-external=true" title="class or interface in org.apache.http"><CODE>HttpConnection</CODE></A>).</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/http/nio/protocol/HttpAsyncService.html#outputReady(org.apache.http.nio.NHttpServerConnection, org.apache.http.nio.ContentEncoder)">outputReady</A></B>(<A HREF="../../../../../org/apache/http/nio/NHttpServerConnection.html" title="interface in org.apache.http.nio">NHttpServerConnection</A>&nbsp;conn,
            <A HREF="../../../../../org/apache/http/nio/ContentEncoder.html" title="interface in org.apache.http.nio">ContentEncoder</A>&nbsp;encoder)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Triggered when the underlying channel is ready for writing a
 next portion of the response entity through the corresponding
 content encoder.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/http/nio/protocol/HttpAsyncService.html#requestReceived(org.apache.http.nio.NHttpServerConnection)">requestReceived</A></B>(<A HREF="../../../../../org/apache/http/nio/NHttpServerConnection.html" title="interface in org.apache.http.nio">NHttpServerConnection</A>&nbsp;conn)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Triggered when a new HTTP request is received.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/http/nio/protocol/HttpAsyncService.html#responseReady(org.apache.http.nio.NHttpServerConnection)">responseReady</A></B>(<A HREF="../../../../../org/apache/http/nio/NHttpServerConnection.html" title="interface in org.apache.http.nio">NHttpServerConnection</A>&nbsp;conn)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Triggered when the connection is ready to accept a new HTTP response.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/http/nio/protocol/HttpAsyncService.html#timeout(org.apache.http.nio.NHttpServerConnection)">timeout</A></B>(<A HREF="../../../../../org/apache/http/nio/NHttpServerConnection.html" title="interface in org.apache.http.nio">NHttpServerConnection</A>&nbsp;conn)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Triggered when no input is detected on this connection over the
 maximum period of inactivity.</TD>
</TR>
</TABLE>
&nbsp;<A NAME="methods_inherited_from_class_java.lang.Object"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#EEEEFF" CLASS="TableSubHeadingColor">
<TH ALIGN="left"><B>Methods inherited from class java.lang.<A HREF="http://download.oracle.com/javase/1.5.0/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</A></B></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><A HREF="http://download.oracle.com/javase/1.5.0/docs/api/java/lang/Object.html?is-external=true#clone()" title="class or interface in java.lang">clone</A>, <A HREF="http://download.oracle.com/javase/1.5.0/docs/api/java/lang/Object.html?is-external=true#equals(java.lang.Object)" title="class or interface in java.lang">equals</A>, <A HREF="http://download.oracle.com/javase/1.5.0/docs/api/java/lang/Object.html?is-external=true#finalize()" title="class or interface in java.lang">finalize</A>, <A HREF="http://download.oracle.com/javase/1.5.0/docs/api/java/lang/Object.html?is-external=true#getClass()" title="class or interface in java.lang">getClass</A>, <A HREF="http://download.oracle.com/javase/1.5.0/docs/api/java/lang/Object.html?is-external=true#hashCode()" title="class or interface in java.lang">hashCode</A>, <A HREF="http://download.oracle.com/javase/1.5.0/docs/api/java/lang/Object.html?is-external=true#notify()" title="class or interface in java.lang">notify</A>, <A HREF="http://download.oracle.com/javase/1.5.0/docs/api/java/lang/Object.html?is-external=true#notifyAll()" title="class or interface in java.lang">notifyAll</A>, <A HREF="http://download.oracle.com/javase/1.5.0/docs/api/java/lang/Object.html?is-external=true#toString()" title="class or interface in java.lang">toString</A>, <A HREF="http://download.oracle.com/javase/1.5.0/docs/api/java/lang/Object.html?is-external=true#wait()" title="class or interface in java.lang">wait</A>, <A HREF="http://download.oracle.com/javase/1.5.0/docs/api/java/lang/Object.html?is-external=true#wait(long)" title="class or interface in java.lang">wait</A>, <A HREF="http://download.oracle.com/javase/1.5.0/docs/api/java/lang/Object.html?is-external=true#wait(long, int)" title="class or interface in java.lang">wait</A></CODE></TD>
</TR>
</TABLE>
&nbsp;
<P>

<!-- ========= CONSTRUCTOR DETAIL ======== -->

<A NAME="constructor_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Constructor Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="HttpAsyncService(org.apache.http.protocol.HttpProcessor, org.apache.http.ConnectionReuseStrategy, org.apache.http.HttpResponseFactory, org.apache.http.nio.protocol.HttpAsyncRequestHandlerResolver, org.apache.http.nio.protocol.HttpAsyncExpectationVerifier, org.apache.http.params.HttpParams)"><!-- --></A><H3>
HttpAsyncService</H3>
<PRE>
public <B>HttpAsyncService</B>(<A HREF="http://hc.apache.org/httpcomponents-core-ga/httpcore/apidocs/org/apache/http/protocol/HttpProcessor.html?is-external=true" title="class or interface in org.apache.http.protocol">HttpProcessor</A>&nbsp;httpProcessor,
                        <A HREF="http://hc.apache.org/httpcomponents-core-ga/httpcore/apidocs/org/apache/http/ConnectionReuseStrategy.html?is-external=true" title="class or interface in org.apache.http">ConnectionReuseStrategy</A>&nbsp;connStrategy,
                        <A HREF="http://hc.apache.org/httpcomponents-core-ga/httpcore/apidocs/org/apache/http/HttpResponseFactory.html?is-external=true" title="class or interface in org.apache.http">HttpResponseFactory</A>&nbsp;responseFactory,
                        <A HREF="../../../../../org/apache/http/nio/protocol/HttpAsyncRequestHandlerResolver.html" title="interface in org.apache.http.nio.protocol">HttpAsyncRequestHandlerResolver</A>&nbsp;handlerResolver,
                        <A HREF="../../../../../org/apache/http/nio/protocol/HttpAsyncExpectationVerifier.html" title="interface in org.apache.http.nio.protocol">HttpAsyncExpectationVerifier</A>&nbsp;expectationVerifier,
                        <A HREF="http://hc.apache.org/httpcomponents-core-ga/httpcore/apidocs/org/apache/http/params/HttpParams.html?is-external=true" title="class or interface in org.apache.http.params">HttpParams</A>&nbsp;params)</PRE>
<DL>
<DD>Creates an instance of <tt>HttpAsyncServerProtocolHandler</tt>.
<P>
<DL>
<DT><B>Parameters:</B><DD><CODE>httpProcessor</CODE> - HTTP protocol processor (required).<DD><CODE>connStrategy</CODE> - Connection re-use strategy (required).<DD><CODE>responseFactory</CODE> - HTTP response factory (required).<DD><CODE>handlerResolver</CODE> - Request handler resolver.<DD><CODE>expectationVerifier</CODE> - Request expectation verifier (optional).<DD><CODE>params</CODE> - HTTP parameters (required).</DL>
</DL>
<HR>

<A NAME="HttpAsyncService(org.apache.http.protocol.HttpProcessor, org.apache.http.ConnectionReuseStrategy, org.apache.http.nio.protocol.HttpAsyncRequestHandlerResolver, org.apache.http.params.HttpParams)"><!-- --></A><H3>
HttpAsyncService</H3>
<PRE>
public <B>HttpAsyncService</B>(<A HREF="http://hc.apache.org/httpcomponents-core-ga/httpcore/apidocs/org/apache/http/protocol/HttpProcessor.html?is-external=true" title="class or interface in org.apache.http.protocol">HttpProcessor</A>&nbsp;httpProcessor,
                        <A HREF="http://hc.apache.org/httpcomponents-core-ga/httpcore/apidocs/org/apache/http/ConnectionReuseStrategy.html?is-external=true" title="class or interface in org.apache.http">ConnectionReuseStrategy</A>&nbsp;connStrategy,
                        <A HREF="../../../../../org/apache/http/nio/protocol/HttpAsyncRequestHandlerResolver.html" title="interface in org.apache.http.nio.protocol">HttpAsyncRequestHandlerResolver</A>&nbsp;handlerResolver,
                        <A HREF="http://hc.apache.org/httpcomponents-core-ga/httpcore/apidocs/org/apache/http/params/HttpParams.html?is-external=true" title="class or interface in org.apache.http.params">HttpParams</A>&nbsp;params)</PRE>
<DL>
<DD>Creates an instance of <tt>HttpAsyncServerProtocolHandler</tt>.
<P>
<DL>
<DT><B>Parameters:</B><DD><CODE>httpProcessor</CODE> - HTTP protocol processor (required).<DD><CODE>connStrategy</CODE> - Connection re-use strategy (required).<DD><CODE>handlerResolver</CODE> - Request handler resolver.<DD><CODE>params</CODE> - HTTP parameters (required).</DL>
</DL>

<!-- ============ METHOD DETAIL ========== -->

<A NAME="method_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Method Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="connected(org.apache.http.nio.NHttpServerConnection)"><!-- --></A><H3>
connected</H3>
<PRE>
public void <B>connected</B>(<A HREF="../../../../../org/apache/http/nio/NHttpServerConnection.html" title="interface in org.apache.http.nio">NHttpServerConnection</A>&nbsp;conn)</PRE>
<DL>
<DD><B>Description copied from interface: <CODE><A HREF="../../../../../org/apache/http/nio/NHttpServerEventHandler.html#connected(org.apache.http.nio.NHttpServerConnection)">NHttpServerEventHandler</A></CODE></B></DD>
<DD>Triggered when a new incoming connection is created.
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="../../../../../org/apache/http/nio/NHttpServerEventHandler.html#connected(org.apache.http.nio.NHttpServerConnection)">connected</A></CODE> in interface <CODE><A HREF="../../../../../org/apache/http/nio/NHttpServerEventHandler.html" title="interface in org.apache.http.nio">NHttpServerEventHandler</A></CODE></DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>conn</CODE> - new incoming connection HTTP connection.</DL>
</DD>
</DL>
<HR>

<A NAME="closed(org.apache.http.nio.NHttpServerConnection)"><!-- --></A><H3>
closed</H3>
<PRE>
public void <B>closed</B>(<A HREF="../../../../../org/apache/http/nio/NHttpServerConnection.html" title="interface in org.apache.http.nio">NHttpServerConnection</A>&nbsp;conn)</PRE>
<DL>
<DD><B>Description copied from interface: <CODE><A HREF="../../../../../org/apache/http/nio/NHttpServerEventHandler.html#closed(org.apache.http.nio.NHttpServerConnection)">NHttpServerEventHandler</A></CODE></B></DD>
<DD>Triggered when the connection is closed.
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="../../../../../org/apache/http/nio/NHttpServerEventHandler.html#closed(org.apache.http.nio.NHttpServerConnection)">closed</A></CODE> in interface <CODE><A HREF="../../../../../org/apache/http/nio/NHttpServerEventHandler.html" title="interface in org.apache.http.nio">NHttpServerEventHandler</A></CODE></DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>conn</CODE> - closed HTTP connection.</DL>
</DD>
</DL>
<HR>

<A NAME="exception(org.apache.http.nio.NHttpServerConnection, java.lang.Exception)"><!-- --></A><H3>
exception</H3>
<PRE>
public void <B>exception</B>(<A HREF="../../../../../org/apache/http/nio/NHttpServerConnection.html" title="interface in org.apache.http.nio">NHttpServerConnection</A>&nbsp;conn,
                      <A HREF="http://download.oracle.com/javase/1.5.0/docs/api/java/lang/Exception.html?is-external=true" title="class or interface in java.lang">Exception</A>&nbsp;cause)</PRE>
<DL>
<DD><B>Description copied from interface: <CODE><A HREF="../../../../../org/apache/http/nio/NHttpServerEventHandler.html#exception(org.apache.http.nio.NHttpServerConnection, java.lang.Exception)">NHttpServerEventHandler</A></CODE></B></DD>
<DD>Triggered if an error occurs during the HTTP exchange.
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="../../../../../org/apache/http/nio/NHttpServerEventHandler.html#exception(org.apache.http.nio.NHttpServerConnection, java.lang.Exception)">exception</A></CODE> in interface <CODE><A HREF="../../../../../org/apache/http/nio/NHttpServerEventHandler.html" title="interface in org.apache.http.nio">NHttpServerEventHandler</A></CODE></DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>conn</CODE> - HTTP connection that caused an I/O error<DD><CODE>cause</CODE> - exception</DL>
</DD>
</DL>
<HR>

<A NAME="requestReceived(org.apache.http.nio.NHttpServerConnection)"><!-- --></A><H3>
requestReceived</H3>
<PRE>
public void <B>requestReceived</B>(<A HREF="../../../../../org/apache/http/nio/NHttpServerConnection.html" title="interface in org.apache.http.nio">NHttpServerConnection</A>&nbsp;conn)
                     throws <A HREF="http://download.oracle.com/javase/1.5.0/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</A>,
                            <A HREF="http://hc.apache.org/httpcomponents-core-ga/httpcore/apidocs/org/apache/http/HttpException.html?is-external=true" title="class or interface in org.apache.http">HttpException</A></PRE>
<DL>
<DD><B>Description copied from interface: <CODE><A HREF="../../../../../org/apache/http/nio/NHttpServerEventHandler.html#requestReceived(org.apache.http.nio.NHttpServerConnection)">NHttpServerEventHandler</A></CODE></B></DD>
<DD>Triggered when a new HTTP request is received. The connection
 passed as a parameter to this method is guaranteed to return
 a valid HTTP request object.
 <p/>
 If the request received encloses a request entity this method will
 be followed a series of
 <A HREF="../../../../../org/apache/http/nio/NHttpServerEventHandler.html#inputReady(org.apache.http.nio.NHttpServerConnection, org.apache.http.nio.ContentDecoder)"><CODE>NHttpServerEventHandler.inputReady(NHttpServerConnection, ContentDecoder)</CODE></A> calls
 to transfer the request content.
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="../../../../../org/apache/http/nio/NHttpServerEventHandler.html#requestReceived(org.apache.http.nio.NHttpServerConnection)">requestReceived</A></CODE> in interface <CODE><A HREF="../../../../../org/apache/http/nio/NHttpServerEventHandler.html" title="interface in org.apache.http.nio">NHttpServerEventHandler</A></CODE></DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>conn</CODE> - HTTP connection that contains a new HTTP request
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://download.oracle.com/javase/1.5.0/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</A></CODE>
<DD><CODE><A HREF="http://hc.apache.org/httpcomponents-core-ga/httpcore/apidocs/org/apache/http/HttpException.html?is-external=true" title="class or interface in org.apache.http">HttpException</A></CODE><DT><B>See Also:</B><DD><A HREF="../../../../../org/apache/http/nio/NHttpServerConnection.html" title="interface in org.apache.http.nio"><CODE>NHttpServerConnection</CODE></A></DL>
</DD>
</DL>
<HR>

<A NAME="inputReady(org.apache.http.nio.NHttpServerConnection, org.apache.http.nio.ContentDecoder)"><!-- --></A><H3>
inputReady</H3>
<PRE>
public void <B>inputReady</B>(<A HREF="../../../../../org/apache/http/nio/NHttpServerConnection.html" title="interface in org.apache.http.nio">NHttpServerConnection</A>&nbsp;conn,
                       <A HREF="../../../../../org/apache/http/nio/ContentDecoder.html" title="interface in org.apache.http.nio">ContentDecoder</A>&nbsp;decoder)
                throws <A HREF="http://download.oracle.com/javase/1.5.0/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</A>,
                       <A HREF="http://hc.apache.org/httpcomponents-core-ga/httpcore/apidocs/org/apache/http/HttpException.html?is-external=true" title="class or interface in org.apache.http">HttpException</A></PRE>
<DL>
<DD><B>Description copied from interface: <CODE><A HREF="../../../../../org/apache/http/nio/NHttpServerEventHandler.html#inputReady(org.apache.http.nio.NHttpServerConnection, org.apache.http.nio.ContentDecoder)">NHttpServerEventHandler</A></CODE></B></DD>
<DD>Triggered when the underlying channel is ready for reading a
 new portion of the request entity through the corresponding
 content decoder.
 <p/>
 If the content consumer is unable to process incoming content,
 input event notifications can be temporarily suspended using
 <A HREF="../../../../../org/apache/http/nio/IOControl.html" title="interface in org.apache.http.nio"><CODE>IOControl</CODE></A> interface (super interface of <A HREF="../../../../../org/apache/http/nio/NHttpServerConnection.html" title="interface in org.apache.http.nio"><CODE>NHttpServerConnection</CODE></A>).
 <p/>
 Please note that the <A HREF="../../../../../org/apache/http/nio/NHttpServerConnection.html" title="interface in org.apache.http.nio"><CODE>NHttpServerConnection</CODE></A> and <A HREF="../../../../../org/apache/http/nio/ContentDecoder.html" title="interface in org.apache.http.nio"><CODE>ContentDecoder</CODE></A>
 objects are not thread-safe and should only be used within the context of
 this method call. The <A HREF="../../../../../org/apache/http/nio/IOControl.html" title="interface in org.apache.http.nio"><CODE>IOControl</CODE></A> object can be shared and used on other
 thread to resume input event notifications when the handler is capable of
 processing more content.
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="../../../../../org/apache/http/nio/NHttpServerEventHandler.html#inputReady(org.apache.http.nio.NHttpServerConnection, org.apache.http.nio.ContentDecoder)">inputReady</A></CODE> in interface <CODE><A HREF="../../../../../org/apache/http/nio/NHttpServerEventHandler.html" title="interface in org.apache.http.nio">NHttpServerEventHandler</A></CODE></DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>conn</CODE> - HTTP connection that can produce a new portion of the
 incoming request content.<DD><CODE>decoder</CODE> - The content decoder to use to read content.
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://download.oracle.com/javase/1.5.0/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</A></CODE>
<DD><CODE><A HREF="http://hc.apache.org/httpcomponents-core-ga/httpcore/apidocs/org/apache/http/HttpException.html?is-external=true" title="class or interface in org.apache.http">HttpException</A></CODE><DT><B>See Also:</B><DD><A HREF="../../../../../org/apache/http/nio/NHttpServerConnection.html" title="interface in org.apache.http.nio"><CODE>NHttpServerConnection</CODE></A>, 
<A HREF="../../../../../org/apache/http/nio/ContentDecoder.html" title="interface in org.apache.http.nio"><CODE>ContentDecoder</CODE></A>, 
<A HREF="../../../../../org/apache/http/nio/IOControl.html" title="interface in org.apache.http.nio"><CODE>IOControl</CODE></A></DL>
</DD>
</DL>
<HR>

<A NAME="responseReady(org.apache.http.nio.NHttpServerConnection)"><!-- --></A><H3>
responseReady</H3>
<PRE>
public void <B>responseReady</B>(<A HREF="../../../../../org/apache/http/nio/NHttpServerConnection.html" title="interface in org.apache.http.nio">NHttpServerConnection</A>&nbsp;conn)
                   throws <A HREF="http://download.oracle.com/javase/1.5.0/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</A>,
                          <A HREF="http://hc.apache.org/httpcomponents-core-ga/httpcore/apidocs/org/apache/http/HttpException.html?is-external=true" title="class or interface in org.apache.http">HttpException</A></PRE>
<DL>
<DD><B>Description copied from interface: <CODE><A HREF="../../../../../org/apache/http/nio/NHttpServerEventHandler.html#responseReady(org.apache.http.nio.NHttpServerConnection)">NHttpServerEventHandler</A></CODE></B></DD>
<DD>Triggered when the connection is ready to accept a new HTTP response.
 The protocol handler does not have to submit a response if it is not
 ready.
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="../../../../../org/apache/http/nio/NHttpServerEventHandler.html#responseReady(org.apache.http.nio.NHttpServerConnection)">responseReady</A></CODE> in interface <CODE><A HREF="../../../../../org/apache/http/nio/NHttpServerEventHandler.html" title="interface in org.apache.http.nio">NHttpServerEventHandler</A></CODE></DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>conn</CODE> - HTTP connection that contains an HTTP response
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://download.oracle.com/javase/1.5.0/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</A></CODE>
<DD><CODE><A HREF="http://hc.apache.org/httpcomponents-core-ga/httpcore/apidocs/org/apache/http/HttpException.html?is-external=true" title="class or interface in org.apache.http">HttpException</A></CODE><DT><B>See Also:</B><DD><A HREF="../../../../../org/apache/http/nio/NHttpServerConnection.html" title="interface in org.apache.http.nio"><CODE>NHttpServerConnection</CODE></A></DL>
</DD>
</DL>
<HR>

<A NAME="outputReady(org.apache.http.nio.NHttpServerConnection, org.apache.http.nio.ContentEncoder)"><!-- --></A><H3>
outputReady</H3>
<PRE>
public void <B>outputReady</B>(<A HREF="../../../../../org/apache/http/nio/NHttpServerConnection.html" title="interface in org.apache.http.nio">NHttpServerConnection</A>&nbsp;conn,
                        <A HREF="../../../../../org/apache/http/nio/ContentEncoder.html" title="interface in org.apache.http.nio">ContentEncoder</A>&nbsp;encoder)
                 throws <A HREF="http://download.oracle.com/javase/1.5.0/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</A></PRE>
<DL>
<DD><B>Description copied from interface: <CODE><A HREF="../../../../../org/apache/http/nio/NHttpServerEventHandler.html#outputReady(org.apache.http.nio.NHttpServerConnection, org.apache.http.nio.ContentEncoder)">NHttpServerEventHandler</A></CODE></B></DD>
<DD>Triggered when the underlying channel is ready for writing a
 next portion of the response entity through the corresponding
 content encoder.
 <p/>
 If the content producer is unable to generate outgoing content,
 output event notifications can be temporarily suspended using
 <A HREF="../../../../../org/apache/http/nio/IOControl.html" title="interface in org.apache.http.nio"><CODE>IOControl</CODE></A> interface (super interface of <A HREF="../../../../../org/apache/http/nio/NHttpServerConnection.html" title="interface in org.apache.http.nio"><CODE>NHttpServerConnection</CODE></A>).
 <p/>
 Please note that the <A HREF="../../../../../org/apache/http/nio/NHttpServerConnection.html" title="interface in org.apache.http.nio"><CODE>NHttpServerConnection</CODE></A> and <A HREF="../../../../../org/apache/http/nio/ContentEncoder.html" title="interface in org.apache.http.nio"><CODE>ContentEncoder</CODE></A>
 objects are not thread-safe and should only be used within the context of
 this method call. The <A HREF="../../../../../org/apache/http/nio/IOControl.html" title="interface in org.apache.http.nio"><CODE>IOControl</CODE></A> object can be shared and used on other
 thread to resume output event notifications when more content is made available.
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="../../../../../org/apache/http/nio/NHttpServerEventHandler.html#outputReady(org.apache.http.nio.NHttpServerConnection, org.apache.http.nio.ContentEncoder)">outputReady</A></CODE> in interface <CODE><A HREF="../../../../../org/apache/http/nio/NHttpServerEventHandler.html" title="interface in org.apache.http.nio">NHttpServerEventHandler</A></CODE></DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>conn</CODE> - HTTP connection that can accommodate a new portion
 of the outgoing response content.<DD><CODE>encoder</CODE> - The content encoder to use to write content.
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://download.oracle.com/javase/1.5.0/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</A></CODE><DT><B>See Also:</B><DD><A HREF="../../../../../org/apache/http/nio/NHttpServerConnection.html" title="interface in org.apache.http.nio"><CODE>NHttpServerConnection</CODE></A>, 
<A HREF="../../../../../org/apache/http/nio/ContentEncoder.html" title="interface in org.apache.http.nio"><CODE>ContentEncoder</CODE></A>, 
<A HREF="../../../../../org/apache/http/nio/IOControl.html" title="interface in org.apache.http.nio"><CODE>IOControl</CODE></A></DL>
</DD>
</DL>
<HR>

<A NAME="endOfInput(org.apache.http.nio.NHttpServerConnection)"><!-- --></A><H3>
endOfInput</H3>
<PRE>
public void <B>endOfInput</B>(<A HREF="../../../../../org/apache/http/nio/NHttpServerConnection.html" title="interface in org.apache.http.nio">NHttpServerConnection</A>&nbsp;conn)
                throws <A HREF="http://download.oracle.com/javase/1.5.0/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</A></PRE>
<DL>
<DD><B>Description copied from interface: <CODE><A HREF="../../../../../org/apache/http/nio/NHttpServerEventHandler.html#endOfInput(org.apache.http.nio.NHttpServerConnection)">NHttpServerEventHandler</A></CODE></B></DD>
<DD>Triggered when the connection is closed by the opposite end point
 (half-closed).
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="../../../../../org/apache/http/nio/NHttpServerEventHandler.html#endOfInput(org.apache.http.nio.NHttpServerConnection)">endOfInput</A></CODE> in interface <CODE><A HREF="../../../../../org/apache/http/nio/NHttpServerEventHandler.html" title="interface in org.apache.http.nio">NHttpServerEventHandler</A></CODE></DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>conn</CODE> - half-closed HTTP connection.
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://download.oracle.com/javase/1.5.0/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</A></CODE></DL>
</DD>
</DL>
<HR>

<A NAME="timeout(org.apache.http.nio.NHttpServerConnection)"><!-- --></A><H3>
timeout</H3>
<PRE>
public void <B>timeout</B>(<A HREF="../../../../../org/apache/http/nio/NHttpServerConnection.html" title="interface in org.apache.http.nio">NHttpServerConnection</A>&nbsp;conn)
             throws <A HREF="http://download.oracle.com/javase/1.5.0/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</A></PRE>
<DL>
<DD><B>Description copied from interface: <CODE><A HREF="../../../../../org/apache/http/nio/NHttpServerEventHandler.html#timeout(org.apache.http.nio.NHttpServerConnection)">NHttpServerEventHandler</A></CODE></B></DD>
<DD>Triggered when no input is detected on this connection over the
 maximum period of inactivity.
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="../../../../../org/apache/http/nio/NHttpServerEventHandler.html#timeout(org.apache.http.nio.NHttpServerConnection)">timeout</A></CODE> in interface <CODE><A HREF="../../../../../org/apache/http/nio/NHttpServerEventHandler.html" title="interface in org.apache.http.nio">NHttpServerEventHandler</A></CODE></DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>conn</CODE> - HTTP connection that caused timeout condition.
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://download.oracle.com/javase/1.5.0/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</A></CODE></DL>
</DD>
</DL>
<HR>

<A NAME="log(java.lang.Exception)"><!-- --></A><H3>
log</H3>
<PRE>
protected void <B>log</B>(<A HREF="http://download.oracle.com/javase/1.5.0/docs/api/java/lang/Exception.html?is-external=true" title="class or interface in java.lang">Exception</A>&nbsp;ex)</PRE>
<DL>
<DD>This method can be used to log I/O exception thrown while closing <A HREF="http://download.oracle.com/javase/1.5.0/docs/api/java/io/Closeable.html?is-external=true" title="class or interface in java.io"><CODE>Closeable</CODE></A>
 objects (such as <A HREF="http://hc.apache.org/httpcomponents-core-ga/httpcore/apidocs/org/apache/http/HttpConnection.html?is-external=true" title="class or interface in org.apache.http"><CODE>HttpConnection</CODE></A>).
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>ex</CODE> - I/O exception thrown by <A HREF="http://download.oracle.com/javase/1.5.0/docs/api/java/io/Closeable.html?is-external=true#close()" title="class or interface in java.io"><CODE>Closeable.close()</CODE></A></DL>
</DD>
</DL>
<HR>

<A NAME="handleException(java.lang.Exception, org.apache.http.protocol.HttpContext)"><!-- --></A><H3>
handleException</H3>
<PRE>
protected <A HREF="../../../../../org/apache/http/nio/protocol/HttpAsyncResponseProducer.html" title="interface in org.apache.http.nio.protocol">HttpAsyncResponseProducer</A> <B>handleException</B>(<A HREF="http://download.oracle.com/javase/1.5.0/docs/api/java/lang/Exception.html?is-external=true" title="class or interface in java.lang">Exception</A>&nbsp;ex,
                                                    <A HREF="http://hc.apache.org/httpcomponents-core-ga/httpcore/apidocs/org/apache/http/protocol/HttpContext.html?is-external=true" title="class or interface in org.apache.http.protocol">HttpContext</A>&nbsp;context)</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<!-- ========= END OF CLASS DATA ========= -->
<HR>


<!-- ======= START OF BOTTOM NAVBAR ====== -->
<A NAME="navbar_bottom"><!-- --></A>
<A HREF="#skip-navbar_bottom" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_bottom_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="class-use/HttpAsyncService.html"><FONT CLASS="NavBarFont1"><B>Use</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../index-all.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../../../org/apache/http/nio/protocol/HttpAsyncResponseProducer.html" title="interface in org.apache.http.nio.protocol"><B>PREV CLASS</B></A>&nbsp;
&nbsp;<A HREF="../../../../../org/apache/http/nio/protocol/HttpRequestExecutionHandler.html" title="interface in org.apache.http.nio.protocol"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../../index.html?org/apache/http/nio/protocol/HttpAsyncService.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="HttpAsyncService.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;NESTED&nbsp;|&nbsp;FIELD&nbsp;|&nbsp;<A HREF="#constructor_summary">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;FIELD&nbsp;|&nbsp;<A HREF="#constructor_detail">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_bottom"></A>
<!-- ======== END OF BOTTOM NAVBAR ======= -->

<HR>
Copyright &#169; 2005-2012 <a href="http://www.apache.org/">The Apache Software Foundation</a>. All Rights Reserved.
</BODY>
</HTML>
